'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require('./defaultStyles');

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

var _ModalDialog = require('./ModalDialog');

var _ModalDialog2 = _interopRequireDefault(_ModalDialog);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SinglePageModal = function SinglePageModal(_ref) {
  var style = _ref.style,
      className = _ref.className,
      onClick = _ref.onClick,
      onMount = _ref.onMount,
      onUnmount = _ref.onUnmount,
      children = _ref.children,
      renderTrigger = _ref.renderTrigger,
      defaultCloseModalButton = _ref.defaultCloseModalButton,
      renderCloseModalButton = _ref.renderCloseModalButton,
      renderHeader = _ref.renderHeader,
      dataTestId = _ref.dataTestId,
      renderBody = _ref.renderBody,
      modalIsOpen = _ref.modalIsOpen,
      setModalIsOpenTo = _ref.setModalIsOpenTo,
      toggleModalIsOpen = _ref.toggleModalIsOpen,
      renderButtons = _ref.renderButtons,
      useStyleTemplate = _ref.useStyleTemplate,
      backgroundProps = _ref.backgroundProps;

  var styleTemplate = useStyleTemplate ? _defaultStyles.modalStyleTemplates[useStyleTemplate] : {};
  var getTriggerProps = function getTriggerProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var style = _ref2.style,
        _onClick = _ref2.onClick,
        className = _ref2.className,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['style', 'onClick', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        toggleModalIsOpen();
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: className ? 'modal__trigger ' + className : 'modal__trigger',
      style: style
    }, props);
  };
  var getBackgroundProps = function getBackgroundProps() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick2 = _ref3.onClick,
        style = _ref3.style,
        className = _ref3.className,
        props = (0, _objectWithoutProperties3.default)(_ref3, ['onClick', 'style', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        e.stopPropagation();
        setModalIsOpenTo(false);
        _onClick2 && _onClick2.apply(undefined, [e].concat(args));
      },
      className: className ? 'modal__background ' + className : 'modal__background',
      style: (0, _extends3.default)({}, styleTemplate.background, style)
    }, props);
  };

  return _react2.default.createElement(
    _react.Fragment,
    null,
    renderTrigger && renderTrigger({ getTriggerProps: getTriggerProps }),
    _react2.default.createElement(
      _RTGTransition2.default,
      { in: modalIsOpen },
      function (_ref4) {
        var transitionStyle = _ref4.style;
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getBackgroundProps({
            style: (0, _extends3.default)({}, transitionStyle, backgroundProps.style),
            className: backgroundProps.className ? 'modal__background ' + backgroundProps.className : 'modal__background'
          })),
          _react2.default.createElement(_ModalDialog2.default, {
            style: style,
            className: className,
            onClick: onClick,
            onMount: onMount,
            onUnmount: onUnmount,
            dataTestId: dataTestId,
            defaultCloseModalButton: defaultCloseModalButton,
            renderHeader: renderHeader,
            renderBody: renderBody ? renderBody : children,
            toggleModalIsOpen: toggleModalIsOpen,
            renderButtons: renderButtons,
            renderCloseModalButton: renderCloseModalButton,
            useStyleTemplate: useStyleTemplate
          })
        );
      }
    )
  );
};

SinglePageModal.defaultProps = {
  defaultCloseModalButton: true
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('modalIsOpen', 'setModalIsOpenTo', false), (0, _recompose.withHandlers)({
  toggleModalIsOpen: function toggleModalIsOpen(_ref5) {
    var setModalIsOpenTo = _ref5.setModalIsOpenTo;
    return function () {
      setModalIsOpenTo(function (x) {
        return !x;
      });
    };
  }
}), (0, _recompose.defaultProps)({
  onMount: function onMount() {},
  onUnmount: function onUnmount() {},
  useStyleTemplate: 'default',
  backgroundProps: {}
}), (0, _recompose.setPropTypes)({
  modalIsOpen: _propTypes2.default.bool.isRequired,
  toggleModalIsOpen: _propTypes2.default.func.isRequired
}));

exports.default = enhance(SinglePageModal);